<template>
  <div class="container">
    <div class="d-flex justify-content-center align-items-center flex-column">
      <form @submit.prevent="onRegister" class="text-left">
        <b-form-group id="input-group-username" label="Username:" label-for="input-username">
          <b-form-input
            id="input-username"
            v-model="user.username"
            type="text"
            required
            placeholder="Enter username"
          ></b-form-input>
        </b-form-group>

        <b-form-group id="input-group-password" label="Password:" label-for="input-password">
          <b-form-input
            id="input-password"
            v-model="user.password"
            type="password"
            required
            placeholder="Enter password"
          ></b-form-input>
        </b-form-group>

        <b-form-group id="input-group-email" label="Email:" label-for="input-email">
          <b-form-input
            id="input-email"
            v-model="user.email"
            type="email"
            required
            placeholder="Enter email"
          ></b-form-input>
        </b-form-group>
        <b-button type="submit" class="w-100 my-2">Register</b-button>
      </form>
      <router-link to="/login">Login</router-link>
      <b-alert variant="danger" class="my-3" v-if="error" show>{{ error }}</b-alert>
    </div>
  </div>
</template>

<script>
export default {
  name: "Register",
  data() {
    return {
      user: {
        username: "",
        password: "",
        email: ""
      },
      error: ""
    };
  },
  methods: {
    onRegister: async function() {
      const { username, password } = this.user;
      if (username.length >= 4 && password.length >= 4) {
        try {
          await this.$http.post("/api/auth/register", { user: this.user });
          this.$store.dispatch("logged", this.user);
          this.$router.push("/main");
        } catch (err) {
          this.error = err.body;
        }
      } else {
        this.error = "Логин или пароль не может быть меньше 4 символов";
      }
    }
  }
};
</script>
<style scoped>
</style>
